-- All code written and maintained by Yewchi 
-- zyewchi@gmail.com

--~ All extensions must register themselves with RegisterExtension(name, funcs)

local extensionFuncs = {}

function RegisterExtension(name, funcs)
	if type(name) ~= "string" or type(funcs) ~= "table" then
		HandleError({code=ERR_INVALID_ARGS, func="RegisterExtension(name = "..(name == nil and "nil" or name)..", funcs = t_"..type(funcs)..")"})
		return
	end
	
	extensionFuncs[name:lower()] = funcs
end

function GetExtensionFuncs(name)
	if name == nil then
if DEBUG then print(audioQsSpecifier..debugSpecifier.."nil passed as extension name to GetExtensionFuncs()") end
		return nil
	end
	
	local nameToLower = name:lower()
	
	if extensionFuncs[nameToLower] == nil then
		return nil
	end
	return extensionFuncs[nameToLower]
end

function GetRegisteredExtensionNames()
	local name_arr = {}
	local i = 1
	for name,_ in pairs(extensionFuncs) do
		name_arr[i] = name
		i = i + 1
	end
	return name_arr
end