-- All code written and maintained by Yewchi 
-- zyewchi@gmail.com

SLASH_AQ1 = "/aq"

local profileTotalTimes = {}

local profileStartTimestamps = {}

Frame_OnLoadMessages = CreateFrame("Frame", "On Load Messages")
Frame_OnLoadMessages:RegisterEvent("PLAYER_ENTERING_WORLD")
Frame_OnLoadMessages:SetScript("OnEvent", function() if SV_Specializations["nextLoadMessage"] ~= nil then print(SV_Specializations["nextLoadMessage"]) SV_Specializations["nextLoadMessage"] = nil end end)

-- TODO incomplete, hard-coded
SlashCmdList["AQ"] = function(msg)
	local args = SplitString(msg, "%s")
	if args ~= nil then 
		if args[1] == "load" and args[2] ~= nil then
			local mySpec = GetSpec()
			local funcs = GetExtensionFuncs(args[2])
			if funcs == nil then
				print(audioQsSpecifier..infoSpecifier.."Extension \""..args[2].."\" is not registered/loaded.\nRegistered extensions are:\n"..PrintableTable(GetRegisteredExtensionNames()))
				return
			end
			if funcs["SpecAllowed"](GetSpec()) then
				GSI_LoadSpecTables(mySpec, funcs)
				SetAbilityAndAuraTables(InitializePrompts(mySpec))
				ReregisterEvents()
				ReloadUI()
				SV_Specializations["nextLoadMessage"] = audioQsSpecifier..infoSpecifier.."Loaded: "..funcs["GetNameDetailed"]()
				return
			else
				print(audioQsSpecifier..infoSpecifier.."Failed! Extension \""..funcs["GetName"]().."\" is not able to be loaded for "..select(SPEC_INFO_NAME, GetSpec()).." "..GetClassInfo(select(UNIT_CLASS_NUM, UnitClass("player"))))
				return
			end
		elseif args[1] == "hush" or args[1] == "quiet" or args[1] == "stop" or args[1] == "shh" or args[1] == "off" then -- TODO google regex lua
			if hushMode == false then
				hushMode = true
				print(audioQsSpecifier..infoSpecifier.."Hush mode on. Type \"/aq go\" in chat to enable AudioQs.")
				return
			else
				print(audioQsSpecifier..infoSpecifier.."Hush mode is already on. Type \"/aq go\" in chat to enable AudioQs.")
				return
			end
		elseif args[1] == "start" or args[1] == "begin" or args[1] == "go" or args[1] == "on" then
			if hushMode == true then 
				hushMode = false
				print(audioQsSpecifier..infoSpecifier.."Hush mode off. AudioQs has been enabled.")
				return
			else
				print(audioQsSpecifier..infoSpecifier.."AudioQs is already enabled.")
				return
			end
		end
	end
	print(audioQsSpecifier..infoSpecifier.."Invalid command.")
end

function SplitString(str, splitter)
	if str == nil or splitter == nil then
		error({code=ERR_INVALID_ARGS, func="splitString(str = "..(str == nil and "nil" or str)..", splitter = "..(splitter == nil and "nil" or splitter)..")"})
	end
	local str_arr = {}
	local i = 1
	for sub in str:gmatch("[^"..splitter.."]+") do
		str_arr[i] = sub
		i = i + 1
	end
	return str_arr
end

function GetSpec()
	return GetSpecializationInfo(GetSpecialization())
end

function Printable(val)
	local t = type(val)
	if val == nil then return "nil"
	elseif t == "number" or t == "string" then return val
	elseif t == "boolean" then return (val and "true" or "false")
	elseif t == "table" then return "[tbl]"
	elseif t == "function" then return "[func]"
	elseif t == "userdata" then return "[ud]"
	elseif t == "thread" then return "[thread]"
	end
	return "[WTF]"
end

-- TODO Messy. Needs edge cases.
function PrintableTable(tbl)
	if type(tbl) ~= "table" then
		return Printable(tbl)..", "
	end
	local str = "{"
	for k,v in pairs(tbl) do
		str = str.."["..(type(k) == "string" and "'"..k.."'" or k).."]="..PrintableTable(v)
	end
	return str.."}"
end